/*
 * leds
 * Linux Editor for D 
 * S as in simple(superfluous) or supperb
 * 
 * by Antonio Monteiro
 */

module leds.Docker;

private import dui.All;

private import leds.FileView;

/**
 * Define what is a Dockable
 */
public:
interface Dockable
{
	void setDocker(Docker docker);
	Widget getWidget();
	char[] getTabName();
	Menu getTabMenu();
}

/**
 * A place to dock widget
 */
public:
class Docker : Dockable
{
	protected:
	char[] name;
	bit horizontal;
	Container parent;
	Menu tabMenu;
	Docker docker;

	/**
	 * This is just to keep a reference to the element so D gc don't deletes them.
	 * not sure if that was the problem on the first place
	 */
	
	Dockable[] dockables;
	
	Notebook notebook;
	
	public:
	this(char[] name)
	{
		this(name,false);
	}
	
	this(char[] name, bit horizontal)
	{
		this.horizontal = horizontal;
		this.name = name.dup;
		notebook = new Notebook;
	}

	Widget getWidget()
	{
		return notebook;
	}
	
	char[] getTabName()
	{
		return name;
	}
	
	Menu getTabMenu()
	{
		if ( tabMenu === null )
		{
			tabMenu = new Menu();
			MenuItem item;
			
			//tabMenu.append(new MenuItem(this,"_Close","tabMenu.close"));
			//tabMenu.append(new MenuItem(this,"_Float","tabMenu.float"));
			tabMenu.append(new MenuItem("test"));
		}
		//return tabMenu;
		return null;
	}

	void setDocker(Docker docker)
	{
		this.docker = docker;
	}

	void dock(Dockable dockable)
	{
		dockable.setDocker(this);
		Menu menu = dockable.getTabMenu();
		// we need to do same trick here
		if ( menu !== null )
		{
			MenuItem item = new MenuItem(dockable.getTabName());
			item.setSubmenu(menu);
			MenuBar mb = new MenuBar();
			mb.append(item);
			notebook.appendPage(dockable.getWidget,mb);
								//new Label(dockable.getTabName()),
								//menu);
		}
		else
		{
			notebook.appendPage(dockable.getWidget(), dockable.getTabName());
		}
		dockables ~= dockable;
	}
	
	void undockCurrent()
	{
		int index = notebook.getCurrentPage();
		notebook.removePage(index);
		// lets do as Walter wants... :p
		for ( int i = index ; i<(dockables.length-1) ;i++)
		{
			dockables[index] = dockables[index+1];
		}
		dockables.length = dockables.length-1;
	}

	void setScrollable(bit scrollable)
	{
		notebook.setScrollable(scrollable);
	}

	void setTabPos(PositionType posType)
	{
		notebook.setTabPos(posType);
	}

	FileView getCurrentFileView()
	{	
		return (FileView)notebook.getNthPage(notebook.getCurrentPage());
	}

	int getNDocks()
	{
		return notebook.getNPages();
	}
	
	void setDockedLabelText(Dockable dockable, char[] labelText)
	{
		notebook.setTabLabelText(dockable.getWidget(), labelText);
	}
		
	void toggleVisible()
	{
//		if ( parent === null )
//		{
//			parent = (Container)getParent();
//			ref();
//			parent.remove(this);
//		}
//		else
//		{
//			parent.add(this);
//			unref();
//			parent = null;
//		}
	}
}