/*
 * leds
 * Linux Editor for D 
 * S as in simple(superfluous) or supperb
 * 
 * by Antonio Monteiro
 */

module leds.Scintilla;

private import def.Types;
private import dui.Utils;
private import dui.Container;

alias void* SurfaceID;

public const int INVALID_POSITION = -1;
public const int SCI_START = 2000;
public const int SCI_OPTIONAL_START = 3000;
public const int SCI_LEXER_START = 4000;
public const int SCI_ADDTEXT = 2001;
public const int SCI_ADDSTYLEDTEXT = 2002;
public const int SCI_INSERTTEXT = 2003;
public const int SCI_CLEARALL = 2004;
public const int SCI_CLEARDOCUMENTSTYLE = 2005;
public const int SCI_GETLENGTH = 2006;
public const int SCI_GETCHARAT = 2007;
public const int SCI_GETCURRENTPOS = 2008;
public const int SCI_GETANCHOR = 2009;
public const int SCI_GETSTYLEAT = 2010;
public const int SCI_REDO = 2011;
public const int SCI_SETUNDOCOLLECTION = 2012;
public const int SCI_SELECTALL = 2013;
public const int SCI_SETSAVEPOINT = 2014;
public const int SCI_GETSTYLEDTEXT = 2015;
public const int SCI_CANREDO = 2016;
public const int SCI_MARKERLINEFROMHANDLE = 2017;
public const int SCI_MARKERDELETEHANDLE = 2018;
public const int SCI_GETUNDOCOLLECTION = 2019;
public const int SCWS_INVISIBLE = 0;
public const int SCWS_VISIBLEALWAYS = 1;
public const int SCWS_VISIBLEAFTERINDENT = 2;
public const int SCI_GETVIEWWS = 2020;
public const int SCI_SETVIEWWS = 2021;
public const int SCI_POSITIONFROMPOINT = 2022;
public const int SCI_POSITIONFROMPOINTCLOSE = 2023;
public const int SCI_GOTOLINE = 2024;
public const int SCI_GOTOPOS = 2025;
public const int SCI_SETANCHOR = 2026;
public const int SCI_GETCURLINE = 2027;
public const int SCI_GETENDSTYLED = 2028;;
public const int SC_EOL_CRLF = 0;
public const int SC_EOL_CR = 1;
public const int SC_EOL_LF = 2;
public const int SCI_CONVERTEOLS = 2029;
public const int SCI_GETEOLMODE = 2030;
public const int SCI_SETEOLMODE = 2031;
public const int SCI_STARTSTYLING = 2032;
public const int SCI_SETSTYLING = 2033;
public const int SCI_GETBUFFEREDDRAW = 2034;
public const int SCI_SETBUFFEREDDRAW = 2035;
public const int SCI_SETTABWIDTH = 2036;
public const int SCI_GETTABWIDTH = 2121;
public const int SC_CP_UTF8 = 65001;
public const int SC_CP_DBCS = 1;
public const int SCI_SETCODEPAGE = 2037;
public const int SCI_SETUSEPALETTE = 2039;
public const int MARKER_MAX = 31;
public const int SC_MARK_CIRCLE = 0;
public const int SC_MARK_ROUNDRECT = 1;
public const int SC_MARK_ARROW = 2;
public const int SC_MARK_SMALLRECT = 3;
public const int SC_MARK_SHORTARROW = 4;
public const int SC_MARK_EMPTY = 5;
public const int SC_MARK_ARROWDOWN = 6;
public const int SC_MARK_MINUS = 7;
public const int SC_MARK_PLUS = 8;
public const int SC_MARK_VLINE = 9;
public const int SC_MARK_LCORNER = 10;
public const int SC_MARK_TCORNER = 11;
public const int SC_MARK_BOXPLUS = 12;
public const int SC_MARK_BOXPLUSCONNECTED = 13;
public const int SC_MARK_BOXMINUS = 14;
public const int SC_MARK_BOXMINUSCONNECTED = 15;
public const int SC_MARK_LCORNERCURVE = 16;
public const int SC_MARK_TCORNERCURVE = 17;
public const int SC_MARK_CIRCLEPLUS = 18;
public const int SC_MARK_CIRCLEPLUSCONNECTED = 19;
public const int SC_MARK_CIRCLEMINUS = 20;
public const int SC_MARK_CIRCLEMINUSCONNECTED = 21;
public const int SC_MARK_BACKGROUND = 22;
public const int SC_MARK_DOTDOTDOT = 23;
public const int SC_MARK_ARROWS = 24;
public const int SC_MARK_PIXMAP = 25;
public const int SC_MARK_CHARACTER = 10000;
public const int SC_MARKNUM_FOLDEREND = 25;
public const int SC_MARKNUM_FOLDEROPENMID = 26;
public const int SC_MARKNUM_FOLDERMIDTAIL = 27;
public const int SC_MARKNUM_FOLDERTAIL = 28;
public const int SC_MARKNUM_FOLDERSUB = 29;
public const int SC_MARKNUM_FOLDER = 30;
public const int SC_MARKNUM_FOLDEROPEN = 31;
public const uint SC_MASK_FOLDERS = 0xFE000000;
public const int SCI_MARKERDEFINE = 2040;
public const int SCI_MARKERSETFORE = 2041;
public const int SCI_MARKERSETBACK = 2042;
public const int SCI_MARKERADD = 2043;
public const int SCI_MARKERDELETE = 2044;
public const int SCI_MARKERDELETEALL = 2045;
public const int SCI_MARKERGET = 2046;
public const int SCI_MARKERNEXT = 2047;
public const int SCI_MARKERPREVIOUS = 2048;
public const int SCI_MARKERDEFINEPIXMAP = 2049;
public const int SC_MARGIN_SYMBOL = 0;
public const int SC_MARGIN_NUMBER = 1;
public const int SCI_SETMARGINTYPEN = 2240;
public const int SCI_GETMARGINTYPEN = 2241;
public const int SCI_SETMARGINWIDTHN = 2242;
public const int SCI_GETMARGINWIDTHN = 2243;
public const int SCI_SETMARGINMASKN = 2244;
public const int SCI_GETMARGINMASKN = 2245;
public const int SCI_SETMARGINSENSITIVEN = 2246;
public const int SCI_GETMARGINSENSITIVEN = 2247;
public const int STYLE_DEFAULT = 32;
public const int STYLE_LINENUMBER = 33;
public const int STYLE_BRACELIGHT = 34;
public const int STYLE_BRACEBAD = 35;
public const int STYLE_CONTROLCHAR = 36;
public const int STYLE_INDENTGUIDE = 37;
public const int STYLE_LASTPREDEFINED = 39;
public const int STYLE_MAX = 127;
public const int SC_CHARSET_ANSI = 0;
public const int SC_CHARSET_DEFAULT = 1;
public const int SC_CHARSET_BALTIC = 186;
public const int SC_CHARSET_CHINESEBIG5 = 136;
public const int SC_CHARSET_EASTEUROPE = 238;
public const int SC_CHARSET_GB2312 = 134;
public const int SC_CHARSET_GREEK = 161;
public const int SC_CHARSET_HANGUL = 129;
public const int SC_CHARSET_MAC = 77;
public const int SC_CHARSET_OEM = 255;
public const int SC_CHARSET_RUSSIAN = 204;
public const int SC_CHARSET_SHIFTJIS = 128;
public const int SC_CHARSET_SYMBOL = 2;
public const int SC_CHARSET_TURKISH = 162;
public const int SC_CHARSET_JOHAB = 130;
public const int SC_CHARSET_HEBREW = 177;
public const int SC_CHARSET_ARABIC = 178;
public const int SC_CHARSET_VIETNAMESE = 163;
public const int SC_CHARSET_THAI = 222;
public const int SCI_STYLECLEARALL = 2050;
public const int SCI_STYLESETFORE = 2051;
public const int SCI_STYLESETBACK = 2052;
public const int SCI_STYLESETBOLD = 2053;
public const int SCI_STYLESETITALIC = 2054;
public const int SCI_STYLESETSIZE = 2055;
public const int SCI_STYLESETFONT = 2056;
public const int SCI_STYLESETEOLFILLED = 2057;
public const int SCI_STYLERESETDEFAULT = 2058;
public const int SCI_STYLESETUNDERLINE = 2059;
public const int SC_CASE_MIXED = 0;
public const int SC_CASE_UPPER = 1;
public const int SC_CASE_LOWER = 2;
public const int SCI_STYLESETCASE = 2060;
public const int SCI_STYLESETCHARACTERSET = 2066;
public const int SCI_STYLESETHOTSPOT = 2409;
public const int SCI_SETSELFORE = 2067;
public const int SCI_SETSELBACK = 2068;
public const int SCI_SETCARETFORE = 2069;
public const int SCI_ASSIGNCMDKEY = 2070;
public const int SCI_CLEARCMDKEY = 2071;
public const int SCI_CLEARALLCMDKEYS = 2072;
public const int SCI_SETSTYLINGEX = 2073;
public const int SCI_STYLESETVISIBLE = 2074;
public const int SCI_GETCARETPERIOD = 2075;
public const int SCI_SETCARETPERIOD = 2076;
public const int SCI_SETWORDCHARS = 2077;
public const int SCI_BEGINUNDOACTION = 2078;
public const int SCI_ENDUNDOACTION = 2079;
public const int INDIC_MAX = 7;
public const int INDIC_PLAIN = 0;
public const int INDIC_SQUIGGLE = 1;
public const int INDIC_TT = 2;
public const int INDIC_DIAGONAL = 3;
public const int INDIC_STRIKE = 4;
public const int INDIC_HIDDEN = 5;
public const int INDIC0_MASK = 0x20;
public const int INDIC1_MASK = 0x40;
public const int INDIC2_MASK = 0x80;
public const int INDICS_MASK = 0xE0;
public const int SCI_INDICSETSTYLE = 2080;
public const int SCI_INDICGETSTYLE = 2081;
public const int SCI_INDICSETFORE = 2082;
public const int SCI_INDICGETFORE = 2083;
public const int SCI_SETWHITESPACEFORE = 2084;
public const int SCI_SETWHITESPACEBACK = 2085;
public const int SCI_SETSTYLEBITS = 2090;
public const int SCI_GETSTYLEBITS = 2091;
public const int SCI_SETLINESTATE = 2092;
public const int SCI_GETLINESTATE = 2093;
public const int SCI_GETMAXLINESTATE = 2094;
public const int SCI_GETCARETLINEVISIBLE = 2095 ;
public const int SCI_SETCARETLINEVISIBLE = 2096 ;
public const int SCI_GETCARETLINEBACK = 2097;
public const int SCI_SETCARETLINEBACK = 2098;
public const int SCI_STYLESETCHANGEABLE = 2099;
public const int SCI_AUTOCSHOW = 2100;
public const int SCI_AUTOCCANCEL = 2101;
public const int SCI_AUTOCACTIVE = 2102;
public const int SCI_AUTOCPOSSTART = 2103;
public const int SCI_AUTOCCOMPLETE = 2104;
public const int SCI_AUTOCSTOPS = 2105;
public const int SCI_AUTOCSETSEPARATOR = 2106;
public const int SCI_AUTOCGETSEPARATOR = 2107;
public const int SCI_AUTOCSELECT = 2108;
public const int SCI_AUTOCSETCANCELATSTART = 2110;
public const int SCI_AUTOCGETCANCELATSTART = 2111;
public const int SCI_AUTOCSETFILLUPS = 2112;
public const int SCI_AUTOCSETCHOOSESINGLE = 2113;
public const int SCI_AUTOCGETCHOOSESINGLE = 2114;
public const int SCI_AUTOCSETIGNORECASE = 2115;
public const int SCI_AUTOCGETIGNORECASE = 2116;
public const int SCI_USERLISTSHOW = 2117;
public const int SCI_AUTOCSETAUTOHIDE = 2118;
public const int SCI_AUTOCGETAUTOHIDE = 2119;
public const int SCI_AUTOCSETDROPRESTOFWORD = 2270;
public const int SCI_AUTOCGETDROPRESTOFWORD = 2271;
public const int SCI_REGISTERIMAGE = 2405;
public const int SCI_CLEARREGISTEREDIMAGES = 2408;
public const int SCI_AUTOCGETTYPESEPARATOR = 2285;
public const int SCI_AUTOCSETTYPESEPARATOR = 2286;
public const int SCI_SETINDENT = 2122;
public const int SCI_GETINDENT = 2123;
public const int SCI_SETUSETABS = 2124;
public const int SCI_GETUSETABS = 2125;
public const int SCI_SETLINEINDENTATION = 2126;
public const int SCI_GETLINEINDENTATION = 2127;
public const int SCI_GETLINEINDENTPOSITION = 2128;
public const int SCI_GETCOLUMN = 2129;
public const int SCI_SETHSCROLLBAR = 2130;
public const int SCI_GETHSCROLLBAR = 2131;
public const int SCI_SETINDENTATIONGUIDES = 2132;
public const int SCI_GETINDENTATIONGUIDES = 2133;
public const int SCI_SETHIGHLIGHTGUIDE = 2134;
public const int SCI_GETHIGHLIGHTGUIDE = 2135;
public const int SCI_GETLINEENDPOSITION = 2136;
public const int SCI_GETCODEPAGE = 2137;
public const int SCI_GETCARETFORE = 2138;
public const int SCI_GETUSEPALETTE = 2139;
public const int SCI_GETREADONLY = 2140;
public const int SCI_SETCURRENTPOS = 2141;
public const int SCI_SETSELECTIONSTART = 2142;
public const int SCI_GETSELECTIONSTART = 2143;
public const int SCI_SETSELECTIONEND = 2144;
public const int SCI_GETSELECTIONEND = 2145;
public const int SCI_SETPRINTMAGNIFICATION = 2146;
public const int SCI_GETPRINTMAGNIFICATION = 2147;
public const int SC_PRINT_NORMAL = 0;
public const int SC_PRINT_INVERTLIGHT = 1;
public const int SC_PRINT_BLACKONWHITE = 2;
public const int SC_PRINT_COLOURONWHITE = 3;
public const int SC_PRINT_COLOURONWHITEDEFAULTBG = 4;
public const int SCI_SETPRINTCOLOURMODE = 2148;
public const int SCI_GETPRINTCOLOURMODE = 2149;
public const int SCFIND_WHOLEWORD = 2;
public const int SCFIND_MATCHCASE = 4;
public const int SCFIND_WORDSTART = 0x00100000;
public const int SCFIND_REGEXP = 0x00200000;
public const int SCFIND_POSIX = 0x00400000;
public const int SCI_FINDTEXT = 2150;
public const int SCI_FORMATRANGE = 2151;
public const int SCI_GETFIRSTVISIBLELINE = 2152 ;
public const int SCI_GETLINE = 2153;
public const int SCI_GETLINECOUNT = 2154;
public const int SCI_SETMARGINLEFT = 2155;
public const int SCI_GETMARGINLEFT = 2156;
public const int SCI_SETMARGINRIGHT = 2157;
public const int SCI_GETMARGINRIGHT = 2158;
public const int SCI_GETMODIFY = 2159;
public const int SCI_SETSEL = 2160;
public const int SCI_GETSELTEXT = 2161;
public const int SCI_GETTEXTRANGE = 2162;
public const int SCI_HIDESELECTION = 2163;
public const int SCI_POINTXFROMPOSITION = 2164;
public const int SCI_POINTYFROMPOSITION = 2165;
public const int SCI_LINEFROMPOSITION = 2166;
public const int SCI_POSITIONFROMLINE = 2167;
public const int SCI_LINESCROLL = 2168;
public const int SCI_SCROLLCARET = 2169;
public const int SCI_REPLACESEL = 2170;
public const int SCI_SETREADONLY = 2171;
public const int SCI_NULL = 2172;
public const int SCI_CANPASTE = 2173;
public const int SCI_CANUNDO = 2174;
public const int SCI_EMPTYUNDOBUFFER = 2175;
public const int SCI_UNDO = 2176;
public const int SCI_CUT = 2177 ;
public const int SCI_COPY = 2178;
public const int SCI_PASTE = 2179;
public const int SCI_CLEAR = 2180;
public const int SCI_SETTEXT = 2181;
public const int SCI_GETTEXT = 2182;
public const int SCI_GETTEXTLENGTH = 2183;
public const int SCI_GETDIRECTFUNCTION = 2184;
public const int SCI_GETDIRECTPOINTER = 2185;
public const int SCI_SETOVERTYPE = 2186;
public const int SCI_GETOVERTYPE = 2187;
public const int SCI_SETCARETWIDTH = 2188;
public const int SCI_GETCARETWIDTH = 2189;
public const int SCI_SETTARGETSTART = 2190;
public const int SCI_GETTARGETSTART = 2191;
public const int SCI_SETTARGETEND = 2192;
public const int SCI_GETTARGETEND = 2193;
public const int SCI_REPLACETARGET = 2194;
public const int SCI_REPLACETARGETRE = 2195;
public const int SCI_SEARCHINTARGET = 2197;
public const int SCI_SETSEARCHFLAGS = 2198;
public const int SCI_GETSEARCHFLAGS = 2199;
public const int SCI_CALLTIPSHOW = 2200;
public const int SCI_CALLTIPCANCEL = 2201;
public const int SCI_CALLTIPACTIVE = 2202;
public const int SCI_CALLTIPPOSSTART = 2203;
public const int SCI_CALLTIPSETHLT = 2204;
public const int SCI_CALLTIPSETBACK = 2205;
public const int SCI_CALLTIPSETFORE = 2206;
public const int SCI_CALLTIPSETFOREHLT = 2207;
public const int SCI_VISIBLEFROMDOCLINE = 2220;
public const int SCI_DOCLINEFROMVISIBLE = 2221;
public const int SC_FOLDLEVELBASE = 0x400;
public const int SC_FOLDLEVELWHITEFLAG = 0x1000 ;
public const int SC_FOLDLEVELHEADERFLAG = 0x2000;
public const int SC_FOLDLEVELBOXHEADERFLAG = 0x4000;
public const int SC_FOLDLEVELBOXFOOTERFLAG = 0x8000;
public const int SC_FOLDLEVELCONTRACTED = 0x10000;
public const int SC_FOLDLEVELUNINDENT = 0x20000 ;
public const int SC_FOLDLEVELNUMBERMASK = 0x0FFF;
public const int SCI_SETFOLDLEVEL = 2222;
public const int SCI_GETFOLDLEVEL = 2223;
public const int SCI_GETLASTCHILD = 2224;
public const int SCI_GETFOLDPARENT = 2225;
public const int SCI_SHOWLINES = 2226;
public const int SCI_HIDELINES = 2227;
public const int SCI_GETLINEVISIBLE = 2228;
public const int SCI_SETFOLDEXPANDED = 2229;
public const int SCI_GETFOLDEXPANDED = 2230;
public const int SCI_TOGGLEFOLD = 2231;
public const int SCI_ENSUREVISIBLE = 2232;
public const int SC_FOLDFLAG_LINEBEFORE_EXPANDED = 0x0002;
public const int SC_FOLDFLAG_LINEBEFORE_CONTRACTED = 0x0004;
public const int SC_FOLDFLAG_LINEAFTER_EXPANDED = 0x0008;
public const int SC_FOLDFLAG_LINEAFTER_CONTRACTED = 0x0010;
public const int SC_FOLDFLAG_LEVELNUMBERS = 0x0040;
public const int SC_FOLDFLAG_BOX = 0x0001;
public const int SCI_SETFOLDFLAGS = 2233;
public const int SCI_ENSUREVISIBLEENFORCEPOLICY = 2234;
public const int SCI_SETTABINDENTS = 2260;
public const int SCI_GETTABINDENTS = 2261;
public const int SCI_SETBACKSPACEUNINDENTS = 2262;
public const int SCI_GETBACKSPACEUNINDENTS = 2263;
public const int SC_TIME_FOREVER = 10000000;
public const int SCI_SETMOUSEDWELLTIME = 2264;
public const int SCI_GETMOUSEDWELLTIME = 2265;
public const int SCI_WORDSTARTPOSITION = 2266;
public const int SCI_WORDENDPOSITION = 2267;
public const int SC_WRAP_NONE = 0;
public const int SC_WRAP_WORD = 1;
public const int SCI_SETWRAPMODE = 2268;
public const int SCI_GETWRAPMODE = 2269;
public const int SC_CACHE_NONE = 0;
public const int SC_CACHE_CARET = 1;
public const int SC_CACHE_PAGE = 2;
public const int SC_CACHE_DOCUMENT = 3;
public const int SCI_SETLAYOUTCACHE = 2272;
public const int SCI_GETLAYOUTCACHE = 2273;
public const int SCI_SETSCROLLWIDTH = 2274;
public const int SCI_GETSCROLLWIDTH = 2275;
public const int SCI_TEXTWIDTH = 2276;
public const int SCI_SETENDATLASTLINE = 2277;
public const int SCI_GETENDATLASTLINE = 2278;
public const int SCI_TEXTHEIGHT = 2279;
public const int SCI_SETVSCROLLBAR = 2280;
public const int SCI_GETVSCROLLBAR = 2281;
public const int SCI_APPENDTEXT = 2282;
public const int SCI_GETTWOPHASEDRAW = 2283;
public const int SCI_SETTWOPHASEDRAW = 2284;
public const int SCI_TARGETFROMSELECTION = 2287 ;
public const int SCI_LINESJOIN = 2288;
public const int SCI_LINESSPLIT = 2289;
public const int SCI_SETFOLDMARGINCOLOUR = 2290 ;
public const int SCI_SETFOLDMARGINHICOLOUR = 2291;
public const int SCI_LINEDOWN = 2300;
public const int SCI_LINEDOWNEXTEND = 2301;
public const int SCI_LINEUP = 2302;
public const int SCI_LINEUPEXTEND = 2303;
public const int SCI_CHARLEFT = 2304;
public const int SCI_CHARLEFTEXTEND = 2305;
public const int SCI_CHARRIGHT = 2306;
public const int SCI_CHARRIGHTEXTEND = 2307;
public const int SCI_WORDLEFT = 2308;
public const int SCI_WORDLEFTEXTEND = 2309;
public const int SCI_WORDRIGHT = 2310;
public const int SCI_WORDRIGHTEXTEND = 2311;
public const int SCI_HOME = 2312;
public const int SCI_HOMEEXTEND = 2313;
public const int SCI_LINEEND = 2314;
public const int SCI_LINEENDEXTEND = 2315;
public const int SCI_DOCUMENTSTART = 2316;
public const int SCI_DOCUMENTSTARTEXTEND = 2317 ;
public const int SCI_DOCUMENTEND = 2318;
public const int SCI_DOCUMENTENDEXTEND = 2319;
public const int SCI_PAGEUP = 2320;
public const int SCI_PAGEUPEXTEND = 2321;
public const int SCI_PAGEDOWN = 2322;
public const int SCI_PAGEDOWNEXTEND = 2323;
public const int SCI_EDITTOGGLEOVERTYPE = 2324;
public const int SCI_CANCEL = 2325;
public const int SCI_DELETEBACK = 2326;
public const int SCI_TAB = 2327 ;
public const int SCI_BACKTAB = 2328;
public const int SCI_NEWLINE = 2329;
public const int SCI_FORMFEED = 2330;
public const int SCI_VCHOME = 2331;
public const int SCI_VCHOMEEXTEND = 2332;
public const int SCI_ZOOMIN = 2333;
public const int SCI_ZOOMOUT = 2334;
public const int SCI_DELWORDLEFT = 2335;
public const int SCI_DELWORDRIGHT = 2336;
public const int SCI_LINECUT = 2337;
public const int SCI_LINEDELETE = 2338;
public const int SCI_LINETRANSPOSE = 2339;
public const int SCI_LINEDUPLICATE = 2404;
public const int SCI_LOWERCASE = 2340;
public const int SCI_UPPERCASE = 2341;
public const int SCI_LINESCROLLDOWN = 2342;
public const int SCI_LINESCROLLUP = 2343;
public const int SCI_DELETEBACKNOTLINE = 2344;
public const int SCI_HOMEDISPLAY = 2345;
public const int SCI_HOMEDISPLAYEXTEND = 2346;
public const int SCI_LINEENDDISPLAY = 2347;
public const int SCI_LINEENDDISPLAYEXTEND = 2348;
public const int SCI_HOMEWRAP = 2349;
public const int SCI_HOMEWRAPEXTEND = 2450;
public const int SCI_LINEENDWRAP = 2451;
public const int SCI_LINEENDWRAPEXTEND = 2452;
public const int SCI_VCHOMEWRAP = 2453;
public const int SCI_VCHOMEWRAPEXTEND = 2454;
public const int SCI_LINECOPY = 2455;
public const int SCI_MOVECARETINSIDEVIEW = 2401 ;
public const int SCI_LINELENGTH = 2350;
public const int SCI_BRACEHIGHLIGHT = 2351;
public const int SCI_BRACEBADLIGHT = 2352;
public const int SCI_BRACEMATCH = 2353;
public const int SCI_GETVIEWEOL = 2355;
public const int SCI_SETVIEWEOL = 2356;
public const int SCI_GETDOCPOINTER = 2357;
public const int SCI_SETDOCPOINTER = 2358;
public const int SCI_SETMODEVENTMASK = 2359;
public const int EDGE_NONE = 0;
public const int EDGE_LINE = 1;
public const int EDGE_BACKGROUND = 2;
public const int SCI_GETEDGECOLUMN = 2360;
public const int SCI_SETEDGECOLUMN = 2361;
public const int SCI_GETEDGEMODE = 2362;
public const int SCI_SETEDGEMODE = 2363;
public const int SCI_GETEDGECOLOUR = 2364;
public const int SCI_SETEDGECOLOUR = 2365;
public const int SCI_SEARCHANCHOR = 2366;
public const int SCI_SEARCHNEXT = 2367;
public const int SCI_SEARCHPREV = 2368;
public const int SCI_LINESONSCREEN = 2370;
public const int SCI_USEPOPUP = 2371;
public const int SCI_SELECTIONISRECTANGLE = 2372;
public const int SCI_SETZOOM = 2373;
public const int SCI_GETZOOM = 2374;
public const int SCI_CREATEDOCUMENT = 2375;
public const int SCI_ADDREFDOCUMENT = 2376;
public const int SCI_RELEASEDOCUMENT = 2377;
public const int SCI_GETMODEVENTMASK = 2378;
public const int SCI_SETFOCUS = 2380;
public const int SCI_GETFOCUS = 2381;
public const int SCI_SETSTATUS = 2382;
public const int SCI_GETSTATUS = 2383;
public const int SCI_SETMOUSEDOWNCAPTURES = 2384;
public const int SCI_GETMOUSEDOWNCAPTURES = 2385;
public const int SC_CURSORNORMAL = -1;
public const int SC_CURSORWAIT = 4;
public const int SCI_SETCURSOR = 2386;
public const int SCI_GETCURSOR = 2387;
public const int SCI_SETCONTROLCHARSYMBOL = 2388;
public const int SCI_GETCONTROLCHARSYMBOL = 2389;
public const int SCI_WORDPARTLEFT = 2390;
public const int SCI_WORDPARTLEFTEXTEND = 2391;
public const int SCI_WORDPARTRIGHT = 2392;
public const int SCI_WORDPARTRIGHTEXTEND = 2393 ;
public const int VISIBLE_SLOP = 0x01;
public const int VISIBLE_STRICT = 0x04;
public const int SCI_SETVISIBLEPOLICY = 2394;
public const int SCI_DELLINELEFT = 2395;
public const int SCI_DELLINERIGHT = 2396;
public const int SCI_SETXOFFSET = 2397;
public const int SCI_GETXOFFSET = 2398;
public const int SCI_CHOOSECARETX = 2399;
public const int SCI_GRABFOCUS = 2400;
public const int CARET_SLOP = 0x01;
public const int CARET_STRICT = 0x04;
public const int CARET_JUMPS = 0x10;
public const int CARET_EVEN = 0x08;
public const int SCI_SETXCARETPOLICY = 2402;
public const int SCI_SETYCARETPOLICY = 2403;
public const int SCI_SETPRINTWRAPMODE = 2406;
public const int SCI_GETPRINTWRAPMODE = 2407;
public const int SCI_SETHOTSPOTACTIVEFORE = 2410;
public const int SCI_SETHOTSPOTACTIVEBACK = 2411;
public const int SCI_SETHOTSPOTACTIVEUNDERLINE = 2412;
public const int SCI_PARADOWN = 2413;
public const int SCI_PARADOWNEXTEND = 2414;
public const int SCI_PARAUP = 2415;
public const int SCI_PARAUPEXTEND = 2416;
public const int SCI_POSITIONBEFORE = 2417;
public const int SCI_POSITIONAFTER = 2418;
public const int SCI_COPYRANGE = 2419;
public const int SCI_COPYTEXT = 2420;
public const int SCI_STARTRECORD = 3001;
public const int SCI_STOPRECORD = 3002;
public const int SCI_SETLEXER = 4001;
public const int SCI_GETLEXER = 4002;
public const int SCI_COLOURISE = 4003;
public const int SCI_SETPROPERTY = 4004;
public const int KEYWORDSET_MAX = 8;
public const int SCI_SETKEYWORDS = 4005;
public const int SCI_SETLEXERLANGUAGE = 4006;
public const int SCI_LOADLEXERLIBRARY = 4007;
public const int SC_MOD_INSERTTEXT = 0x1;
public const int SC_MOD_DELETETEXT = 0x2;
public const int SC_MOD_CHANGESTYLE = 0x4;
public const int SC_MOD_CHANGEFOLD = 0x8;
public const int SC_PERFORMED_USER = 0x10;
public const int SC_PERFORMED_UNDO = 0x20;
public const int SC_PERFORMED_REDO = 0x40;
public const int SC_LASTSTEPINUNDOREDO = 0x100;
public const int SC_MOD_CHANGEMARKER = 0x200;
public const int SC_MOD_BEFOREINSERT = 0x400;
public const int SC_MOD_BEFOREDELETE = 0x800;
public const int SC_MODEVENTMASKALL = 0xF77;
public const int SCEN_CHANGE = 768;
public const int SCEN_SETFOCUS = 512;
public const int SCEN_KILLFOCUS = 256;
public const int SCK_DOWN = 300 ;
public const int SCK_UP = 301;
public const int SCK_LEFT = 302 ;
public const int SCK_RIGHT = 303;
public const int SCK_HOME = 304 ;
public const int SCK_END = 305;
public const int SCK_PRIOR = 306;
public const int SCK_NEXT = 307 ;
public const int SCK_DELETE = 308;
public const int SCK_INSERT = 309;
public const int SCK_ESCAPE = 7 ;
public const int SCK_BACK = 8;
public const int SCK_TAB = 9;
public const int SCK_RETURN = 13;
public const int SCK_ADD = 310;
public const int SCK_SUBTRACT = 311;
public const int SCK_DIVIDE = 312;
public const int SCMOD_SHIFT = 1;
public const int SCMOD_CTRL = 2 ;
public const int SCMOD_ALT = 4;
public const int SCN_STYLENEEDED = 2000;
public const int SCN_CHARADDED = 2001;
public const int SCN_SAVEPOINTREACHED = 2002;
public const int SCN_SAVEPOINTLEFT = 2003;
public const int SCN_MODIFYATTEMPTRO = 2004;
public const int SCN_KEY = 2005 ;
public const int SCN_DOUBLECLICK = 2006;
public const int SCN_UPDATEUI = 2007;
public const int SCN_MODIFIED = 2008;
public const int SCN_MACRORECORD = 2009;
public const int SCN_MARGINCLICK = 2010;
public const int SCN_NEEDSHOWN = 2011;
public const int SCN_PAINTED = 2013;
public const int SCN_USERLISTSELECTION = 2014;
public const int SCN_URIDROPPED = 2015;
public const int SCN_DWELLSTART = 2016;
public const int SCN_DWELLEND = 2017;
public const int SCN_ZOOM = 2018;
public const int SCN_HOTSPOTCLICK = 2019;
public const int SCN_HOTSPOTDOUBLECLICK = 2020;
public const int SCN_CALLTIPCLICK = 2021;

// start_new_consts
//public const int INVALID_POSITION=-1;
//public const int SCI_START=2000;
//public const int SCI_OPTIONAL_START=3000;
//public const int SCI_LEXER_START=4000;
//public const int SCWS_INVISIBLE=0;
//public const int SCWS_VISIBLEALWAYS=1;
//public const int SCWS_VISIBLEAFTERINDENT=2;
//public const int SC_EOL_CRLF=0;
//public const int SC_EOL_CR=1;
//public const int SC_EOL_LF=2;
//public const int SC_CP_UTF8=65001;
//public const int SC_CP_DBCS=1;
//public const int MARKER_MAX=31;
//public const int SC_MARK_CIRCLE=0;
//public const int SC_MARK_ROUNDRECT=1;
//public const int SC_MARK_ARROW=2;
//public const int SC_MARK_SMALLRECT=3;
//public const int SC_MARK_SHORTARROW=4;
//public const int SC_MARK_EMPTY=5;
//public const int SC_MARK_ARROWDOWN=6;
//public const int SC_MARK_MINUS=7;
//public const int SC_MARK_PLUS=8;
//public const int SC_MARK_VLINE=9;
//public const int SC_MARK_LCORNER=10;
//public const int SC_MARK_TCORNER=11;
//public const int SC_MARK_BOXPLUS=12;
//public const int SC_MARK_BOXPLUSCONNECTED=13;
//public const int SC_MARK_BOXMINUS=14;
//public const int SC_MARK_BOXMINUSCONNECTED=15;
//public const int SC_MARK_LCORNERCURVE=16;
//public const int SC_MARK_TCORNERCURVE=17;
//public const int SC_MARK_CIRCLEPLUS=18;
//public const int SC_MARK_CIRCLEPLUSCONNECTED=19;
//public const int SC_MARK_CIRCLEMINUS=20;
//public const int SC_MARK_CIRCLEMINUSCONNECTED=21;
//public const int SC_MARK_BACKGROUND=22;
//public const int SC_MARK_DOTDOTDOT=23;
//public const int SC_MARK_ARROWS=24;
//public const int SC_MARK_PIXMAP=25;
//public const int SC_MARK_CHARACTER=10000;
//public const int SC_MARKNUM_FOLDEREND=25;
//public const int SC_MARKNUM_FOLDEROPENMID=26;
//public const int SC_MARKNUM_FOLDERMIDTAIL=27;
//public const int SC_MARKNUM_FOLDERTAIL=28;
//public const int SC_MARKNUM_FOLDERSUB=29;
//public const int SC_MARKNUM_FOLDER=30;
//public const int SC_MARKNUM_FOLDEROPEN=31;
//public const int SC_MASK_FOLDERS=0xFE000000;
//public const int SC_MARGIN_SYMBOL=0;
//public const int SC_MARGIN_NUMBER=1;
//public const int STYLE_DEFAULT=32;
//public const int STYLE_LINENUMBER=33;
//public const int STYLE_BRACELIGHT=34;
//public const int STYLE_BRACEBAD=35;
//public const int STYLE_CONTROLCHAR=36;
//public const int STYLE_INDENTGUIDE=37;
//public const int STYLE_LASTPREDEFINED=39;
//public const int STYLE_MAX=127;
//public const int SC_CHARSET_ANSI=0;
//public const int SC_CHARSET_DEFAULT=1;
//public const int SC_CHARSET_BALTIC=186;
//public const int SC_CHARSET_CHINESEBIG5=136;
//public const int SC_CHARSET_EASTEUROPE=238;
//public const int SC_CHARSET_GB2312=134;
//public const int SC_CHARSET_GREEK=161;
//public const int SC_CHARSET_HANGUL=129;
//public const int SC_CHARSET_MAC=77;
//public const int SC_CHARSET_OEM=255;
//public const int SC_CHARSET_RUSSIAN=204;
//public const int SC_CHARSET_SHIFTJIS=128;
//public const int SC_CHARSET_SYMBOL=2;
//public const int SC_CHARSET_TURKISH=162;
//public const int SC_CHARSET_JOHAB=130;
//public const int SC_CHARSET_HEBREW=177;
//public const int SC_CHARSET_ARABIC=178;
//public const int SC_CHARSET_VIETNAMESE=163;
//public const int SC_CHARSET_THAI=222;
//public const int SC_CASE_MIXED=0;
//public const int SC_CASE_UPPER=1;
//public const int SC_CASE_LOWER=2;
//public const int INDIC_MAX=7;
//public const int INDIC_PLAIN=0;
//public const int INDIC_SQUIGGLE=1;
//public const int INDIC_TT=2;
//public const int INDIC_DIAGONAL=3;
//public const int INDIC_STRIKE=4;
//public const int INDIC_HIDDEN=5;
//public const int INDIC_BOX=6;
//public const int INDIC0_MASK=0x20;
//public const int INDIC1_MASK=0x40;
//public const int INDIC2_MASK=0x80;
//public const int INDICS_MASK=0xE0;
//public const int SC_PRINT_NORMAL=0;
//public const int SC_PRINT_INVERTLIGHT=1;
//public const int SC_PRINT_BLACKONWHITE=2;
//public const int SC_PRINT_COLOURONWHITE=3;
//public const int SC_PRINT_COLOURONWHITEDEFAULTBG=4;
//public const int SCFIND_WHOLEWORD=2;
//public const int SCFIND_MATCHCASE=4;
//public const int SCFIND_WORDSTART=0x00100000;
//public const int SCFIND_REGEXP=0x00200000;
//public const int SCFIND_POSIX=0x00400000;
//public const int SC_FOLDLEVELBASE=0x400;
//public const int SC_FOLDLEVELWHITEFLAG=0x1000;
//public const int SC_FOLDLEVELHEADERFLAG=0x2000;
//public const int SC_FOLDLEVELBOXHEADERFLAG=0x4000;
//public const int SC_FOLDLEVELBOXFOOTERFLAG=0x8000;
//public const int SC_FOLDLEVELCONTRACTED=0x10000;
//public const int SC_FOLDLEVELUNINDENT=0x20000;
//public const int SC_FOLDLEVELNUMBERMASK=0x0FFF;
//public const int SC_FOLDFLAG_LINEBEFORE_EXPANDED=0x0002;
//public const int SC_FOLDFLAG_LINEBEFORE_CONTRACTED=0x0004;
//public const int SC_FOLDFLAG_LINEAFTER_EXPANDED=0x0008;
//public const int SC_FOLDFLAG_LINEAFTER_CONTRACTED=0x0010;
//public const int SC_FOLDFLAG_LEVELNUMBERS=0x0040;
//public const int SC_FOLDFLAG_BOX=0x0001;
//public const int SC_TIME_FOREVER=10000000;
//public const int SC_WRAP_NONE=0;
//public const int SC_WRAP_WORD=1;
//public const int SC_CACHE_NONE=0;
//public const int SC_CACHE_CARET=1;
//public const int SC_CACHE_PAGE=2;
//public const int SC_CACHE_DOCUMENT=3;
//public const int EDGE_NONE=0;
//public const int EDGE_LINE=1;
//public const int EDGE_BACKGROUND=2;
//public const int SC_CURSORNORMAL=-1;
//public const int SC_CURSORWAIT=4;
//public const int VISIBLE_SLOP=0x01;
//public const int VISIBLE_STRICT=0x04;
//public const int CARET_SLOP=0x01;
//public const int CARET_STRICT=0x04;
//public const int CARET_JUMPS=0x10;
//public const int CARET_EVEN=0x08;
//public const int KEYWORDSET_MAX=8;
//public const int SC_MOD_INSERTTEXT=0x1;
//public const int SC_MOD_DELETETEXT=0x2;
//public const int SC_MOD_CHANGESTYLE=0x4;
//public const int SC_MOD_CHANGEFOLD=0x8;
//public const int SC_PERFORMED_USER=0x10;
//public const int SC_PERFORMED_UNDO=0x20;
//public const int SC_PERFORMED_REDO=0x40;
//public const int SC_LASTSTEPINUNDOREDO=0x100;
//public const int SC_MOD_CHANGEMARKER=0x200;
//public const int SC_MOD_BEFOREINSERT=0x400;
//public const int SC_MOD_BEFOREDELETE=0x800;
//public const int SC_MODEVENTMASKALL=0xF77;
//public const int SCEN_CHANGE=768;
//public const int SCEN_SETFOCUS=512;
//public const int SCEN_KILLFOCUS=256;
//public const int SCK_DOWN=300;
//public const int SCK_UP=301;
//public const int SCK_LEFT=302;
//public const int SCK_RIGHT=303;
//public const int SCK_HOME=304;
//public const int SCK_END=305;
//public const int SCK_PRIOR=306;
//public const int SCK_NEXT=307;
//public const int SCK_DELETE=308;
//public const int SCK_INSERT=309;
//public const int SCK_ESCAPE=7;
//public const int SCK_BACK=8;
//public const int SCK_TAB=9;
//public const int SCK_RETURN=13;
//public const int SCK_ADD=310;
//public const int SCK_SUBTRACT=311;
//public const int SCK_DIVIDE=312;
//public const int SCMOD_SHIFT=1;
//public const int SCMOD_CTRL=2;
//public const int SCMOD_ALT=4;
public const int SCLEX_CONTAINER=0;
public const int SCLEX_NULL=1;
public const int SCLEX_PYTHON=2;
public const int SCLEX_CPP=3;
public const int SCLEX_HTML=4;
public const int SCLEX_XML=5;
public const int SCLEX_PERL=6;
public const int SCLEX_SQL=7;
public const int SCLEX_VB=8;
public const int SCLEX_PROPERTIES=9;
public const int SCLEX_ERRORLIST=10;
public const int SCLEX_MAKEFILE=11;
public const int SCLEX_BATCH=12;
public const int SCLEX_XCODE=13;
public const int SCLEX_LATEX=14;
public const int SCLEX_LUA=15;
public const int SCLEX_DIFF=16;
public const int SCLEX_CONF=17;
public const int SCLEX_PASCAL=18;
public const int SCLEX_AVE=19;
public const int SCLEX_ADA=20;
public const int SCLEX_LISP=21;
public const int SCLEX_RUBY=22;
public const int SCLEX_EIFFEL=23;
public const int SCLEX_EIFFELKW=24;
public const int SCLEX_TCL=25;
public const int SCLEX_NNCRONTAB=26;
public const int SCLEX_BULLANT=27;
public const int SCLEX_VBSCRIPT=28;
public const int SCLEX_ASP=29;
public const int SCLEX_PHP=30;
public const int SCLEX_BAAN=31;
public const int SCLEX_MATLAB=32;
public const int SCLEX_SCRIPTOL=33;
public const int SCLEX_ASM=34;
public const int SCLEX_CPPNOCASE=35;
public const int SCLEX_FORTRAN=36;
public const int SCLEX_F77=37;
public const int SCLEX_CSS=38;
public const int SCLEX_POV=39;
public const int SCLEX_LOUT=40;
public const int SCLEX_ESCRIPT=41;
public const int SCLEX_PS=42;
public const int SCLEX_NSIS=43;
public const int SCLEX_MMIXAL=44;
public const int SCLEX_CLW=45;
public const int SCLEX_CLWNOCASE=46;
public const int SCLEX_LOT=47;
public const int SCLEX_YAML=48;
public const int SCLEX_AUTOMATIC=1000;
public const int SCE_P_DEFAULT=0;
public const int SCE_P_COMMENTLINE=1;
public const int SCE_P_NUMBER=2;
public const int SCE_P_STRING=3;
public const int SCE_P_CHARACTER=4;
public const int SCE_P_WORD=5;
public const int SCE_P_TRIPLE=6;
public const int SCE_P_TRIPLEDOUBLE=7;
public const int SCE_P_CLASSNAME=8;
public const int SCE_P_DEFNAME=9;
public const int SCE_P_OPERATOR=10;
public const int SCE_P_IDENTIFIER=11;
public const int SCE_P_COMMENTBLOCK=12;
public const int SCE_P_STRINGEOL=13;
public const int SCE_C_DEFAULT=0;
public const int SCE_C_COMMENT=1;
public const int SCE_C_COMMENTLINE=2;
public const int SCE_C_COMMENTDOC=3;
public const int SCE_C_NUMBER=4;
public const int SCE_C_WORD=5;
public const int SCE_C_STRING=6;
public const int SCE_C_CHARACTER=7;
public const int SCE_C_UUID=8;
public const int SCE_C_PREPROCESSOR=9;
public const int SCE_C_OPERATOR=10;
public const int SCE_C_IDENTIFIER=11;
public const int SCE_C_STRINGEOL=12;
public const int SCE_C_VERBATIM=13;
public const int SCE_C_REGEX=14;
public const int SCE_C_COMMENTLINEDOC=15;
public const int SCE_C_WORD2=16;
public const int SCE_C_COMMENTDOCKEYWORD=17;
public const int SCE_C_COMMENTDOCKEYWORDERROR=18;
public const int SCE_C_GLOBALCLASS=19;
public const int SCE_H_DEFAULT=0;
public const int SCE_H_TAG=1;
public const int SCE_H_TAGUNKNOWN=2;
public const int SCE_H_ATTRIBUTE=3;
public const int SCE_H_ATTRIBUTEUNKNOWN=4;
public const int SCE_H_NUMBER=5;
public const int SCE_H_DOUBLESTRING=6;
public const int SCE_H_SINGLESTRING=7;
public const int SCE_H_OTHER=8;
public const int SCE_H_COMMENT=9;
public const int SCE_H_ENTITY=10;
public const int SCE_H_TAGEND=11;
public const int SCE_H_XMLSTART=12;
public const int SCE_H_XMLEND=13;
public const int SCE_H_SCRIPT=14;
public const int SCE_H_ASP=15;
public const int SCE_H_ASPAT=16;
public const int SCE_H_CDATA=17;
public const int SCE_H_QUESTION=18;
public const int SCE_H_VALUE=19;
public const int SCE_H_XCCOMMENT=20;
public const int SCE_H_SGML_DEFAULT=21;
public const int SCE_H_SGML_COMMAND=22;
public const int SCE_H_SGML_1ST_PARAM=23;
public const int SCE_H_SGML_DOUBLESTRING=24;
public const int SCE_H_SGML_SIMPLESTRING=25;
public const int SCE_H_SGML_ERROR=26;
public const int SCE_H_SGML_SPECIAL=27;
public const int SCE_H_SGML_ENTITY=28;
public const int SCE_H_SGML_COMMENT=29;
public const int SCE_H_SGML_1ST_PARAM_COMMENT=30;
public const int SCE_H_SGML_BLOCK_DEFAULT=31;
public const int SCE_HJ_START=40;
public const int SCE_HJ_DEFAULT=41;
public const int SCE_HJ_COMMENT=42;
public const int SCE_HJ_COMMENTLINE=43;
public const int SCE_HJ_COMMENTDOC=44;
public const int SCE_HJ_NUMBER=45;
public const int SCE_HJ_WORD=46;
public const int SCE_HJ_KEYWORD=47;
public const int SCE_HJ_DOUBLESTRING=48;
public const int SCE_HJ_SINGLESTRING=49;
public const int SCE_HJ_SYMBOLS=50;
public const int SCE_HJ_STRINGEOL=51;
public const int SCE_HJ_REGEX=52;
public const int SCE_HJA_START=55;
public const int SCE_HJA_DEFAULT=56;
public const int SCE_HJA_COMMENT=57;
public const int SCE_HJA_COMMENTLINE=58;
public const int SCE_HJA_COMMENTDOC=59;
public const int SCE_HJA_NUMBER=60;
public const int SCE_HJA_WORD=61;
public const int SCE_HJA_KEYWORD=62;
public const int SCE_HJA_DOUBLESTRING=63;
public const int SCE_HJA_SINGLESTRING=64;
public const int SCE_HJA_SYMBOLS=65;
public const int SCE_HJA_STRINGEOL=66;
public const int SCE_HJA_REGEX=67;
public const int SCE_HB_START=70;
public const int SCE_HB_DEFAULT=71;
public const int SCE_HB_COMMENTLINE=72;
public const int SCE_HB_NUMBER=73;
public const int SCE_HB_WORD=74;
public const int SCE_HB_STRING=75;
public const int SCE_HB_IDENTIFIER=76;
public const int SCE_HB_STRINGEOL=77;
public const int SCE_HBA_START=80;
public const int SCE_HBA_DEFAULT=81;
public const int SCE_HBA_COMMENTLINE=82;
public const int SCE_HBA_NUMBER=83;
public const int SCE_HBA_WORD=84;
public const int SCE_HBA_STRING=85;
public const int SCE_HBA_IDENTIFIER=86;
public const int SCE_HBA_STRINGEOL=87;
public const int SCE_HP_START=90;
public const int SCE_HP_DEFAULT=91;
public const int SCE_HP_COMMENTLINE=92;
public const int SCE_HP_NUMBER=93;
public const int SCE_HP_STRING=94;
public const int SCE_HP_CHARACTER=95;
public const int SCE_HP_WORD=96;
public const int SCE_HP_TRIPLE=97;
public const int SCE_HP_TRIPLEDOUBLE=98;
public const int SCE_HP_CLASSNAME=99;
public const int SCE_HP_DEFNAME=100;
public const int SCE_HP_OPERATOR=101;
public const int SCE_HP_IDENTIFIER=102;
public const int SCE_HPA_START=105;
public const int SCE_HPA_DEFAULT=106;
public const int SCE_HPA_COMMENTLINE=107;
public const int SCE_HPA_NUMBER=108;
public const int SCE_HPA_STRING=109;
public const int SCE_HPA_CHARACTER=110;
public const int SCE_HPA_WORD=111;
public const int SCE_HPA_TRIPLE=112;
public const int SCE_HPA_TRIPLEDOUBLE=113;
public const int SCE_HPA_CLASSNAME=114;
public const int SCE_HPA_DEFNAME=115;
public const int SCE_HPA_OPERATOR=116;
public const int SCE_HPA_IDENTIFIER=117;
public const int SCE_HPHP_DEFAULT=118;
public const int SCE_HPHP_HSTRING=119;
public const int SCE_HPHP_SIMPLESTRING=120;
public const int SCE_HPHP_WORD=121;
public const int SCE_HPHP_NUMBER=122;
public const int SCE_HPHP_VARIABLE=123;
public const int SCE_HPHP_COMMENT=124;
public const int SCE_HPHP_COMMENTLINE=125;
public const int SCE_HPHP_HSTRING_VARIABLE=126;
public const int SCE_HPHP_OPERATOR=127;
public const int SCE_PL_DEFAULT=0;
public const int SCE_PL_ERROR=1;
public const int SCE_PL_COMMENTLINE=2;
public const int SCE_PL_POD=3;
public const int SCE_PL_NUMBER=4;
public const int SCE_PL_WORD=5;
public const int SCE_PL_STRING=6;
public const int SCE_PL_CHARACTER=7;
public const int SCE_PL_PUNCTUATION=8;
public const int SCE_PL_PREPROCESSOR=9;
public const int SCE_PL_OPERATOR=10;
public const int SCE_PL_IDENTIFIER=11;
public const int SCE_PL_SCALAR=12;
public const int SCE_PL_ARRAY=13;
public const int SCE_PL_HASH=14;
public const int SCE_PL_SYMBOLTABLE=15;
public const int SCE_PL_REGEX=17;
public const int SCE_PL_REGSUBST=18;
public const int SCE_PL_LONGQUOTE=19;
public const int SCE_PL_BACKTICKS=20;
public const int SCE_PL_DATASECTION=21;
public const int SCE_PL_HERE_DELIM=22;
public const int SCE_PL_HERE_Q=23;
public const int SCE_PL_HERE_QQ=24;
public const int SCE_PL_HERE_QX=25;
public const int SCE_PL_STRING_Q=26;
public const int SCE_PL_STRING_QQ=27;
public const int SCE_PL_STRING_QX=28;
public const int SCE_PL_STRING_QR=29;
public const int SCE_PL_STRING_QW=30;
public const int SCE_B_DEFAULT=0;
public const int SCE_B_COMMENT=1;
public const int SCE_B_NUMBER=2;
public const int SCE_B_KEYWORD=3;
public const int SCE_B_STRING=4;
public const int SCE_B_PREPROCESSOR=5;
public const int SCE_B_OPERATOR=6;
public const int SCE_B_IDENTIFIER=7;
public const int SCE_B_DATE=8;
public const int SCE_PROPS_DEFAULT=0;
public const int SCE_PROPS_COMMENT=1;
public const int SCE_PROPS_SECTION=2;
public const int SCE_PROPS_ASSIGNMENT=3;
public const int SCE_PROPS_DEFVAL=4;
public const int SCE_L_DEFAULT=0;
public const int SCE_L_COMMAND=1;
public const int SCE_L_TAG=2;
public const int SCE_L_MATH=3;
public const int SCE_L_COMMENT=4;
public const int SCE_LUA_DEFAULT=0;
public const int SCE_LUA_COMMENT=1;
public const int SCE_LUA_COMMENTLINE=2;
public const int SCE_LUA_COMMENTDOC=3;
public const int SCE_LUA_NUMBER=4;
public const int SCE_LUA_WORD=5;
public const int SCE_LUA_STRING=6;
public const int SCE_LUA_CHARACTER=7;
public const int SCE_LUA_LITERALSTRING=8;
public const int SCE_LUA_PREPROCESSOR=9;
public const int SCE_LUA_OPERATOR=10;
public const int SCE_LUA_IDENTIFIER=11;
public const int SCE_LUA_STRINGEOL=12;
public const int SCE_LUA_WORD2=13;
public const int SCE_LUA_WORD3=14;
public const int SCE_LUA_WORD4=15;
public const int SCE_LUA_WORD5=16;
public const int SCE_LUA_WORD6=17;
public const int SCE_LUA_WORD7=18;
public const int SCE_LUA_WORD8=19;
public const int SCE_ERR_DEFAULT=0;
public const int SCE_ERR_PYTHON=1;
public const int SCE_ERR_GCC=2;
public const int SCE_ERR_MS=3;
public const int SCE_ERR_CMD=4;
public const int SCE_ERR_BORLAND=5;
public const int SCE_ERR_PERL=6;
public const int SCE_ERR_NET=7;
public const int SCE_ERR_LUA=8;
public const int SCE_ERR_CTAG=9;
public const int SCE_ERR_DIFF_CHANGED=10;
public const int SCE_ERR_DIFF_ADDITION=11;
public const int SCE_ERR_DIFF_DELETION=12;
public const int SCE_ERR_DIFF_MESSAGE=13;
public const int SCE_ERR_PHP=14;
public const int SCE_ERR_ELF=15;
public const int SCE_ERR_IFC=16;
public const int SCE_BAT_DEFAULT=0;
public const int SCE_BAT_COMMENT=1;
public const int SCE_BAT_WORD=2;
public const int SCE_BAT_LABEL=3;
public const int SCE_BAT_HIDE=4;
public const int SCE_BAT_COMMAND=5;
public const int SCE_BAT_IDENTIFIER=6;
public const int SCE_BAT_OPERATOR=7;
public const int SCE_MAKE_DEFAULT=0;
public const int SCE_MAKE_COMMENT=1;
public const int SCE_MAKE_PREPROCESSOR=2;
public const int SCE_MAKE_IDENTIFIER=3;
public const int SCE_MAKE_OPERATOR=4;
public const int SCE_MAKE_TARGET=5;
public const int SCE_MAKE_IDEOL=9;
public const int SCE_DIFF_DEFAULT=0;
public const int SCE_DIFF_COMMENT=1;
public const int SCE_DIFF_COMMAND=2;
public const int SCE_DIFF_HEADER=3;
public const int SCE_DIFF_POSITION=4;
public const int SCE_DIFF_DELETED=5;
public const int SCE_DIFF_ADDED=6;
public const int SCE_CONF_DEFAULT=0;
public const int SCE_CONF_COMMENT=1;
public const int SCE_CONF_NUMBER=2;
public const int SCE_CONF_IDENTIFIER=3;
public const int SCE_CONF_EXTENSION=4;
public const int SCE_CONF_PARAMETER=5;
public const int SCE_CONF_STRING=6;
public const int SCE_CONF_OPERATOR=7;
public const int SCE_CONF_IP=8;
public const int SCE_CONF_DIRECTIVE=9;
public const int SCE_AVE_DEFAULT=0;
public const int SCE_AVE_COMMENT=1;
public const int SCE_AVE_NUMBER=2;
public const int SCE_AVE_WORD=3;
public const int SCE_AVE_STRING=6;
public const int SCE_AVE_ENUM=7;
public const int SCE_AVE_STRINGEOL=8;
public const int SCE_AVE_IDENTIFIER=9;
public const int SCE_AVE_OPERATOR=10;
public const int SCE_AVE_WORD1=11;
public const int SCE_AVE_WORD2=12;
public const int SCE_AVE_WORD3=13;
public const int SCE_AVE_WORD4=14;
public const int SCE_AVE_WORD5=15;
public const int SCE_AVE_WORD6=16;
public const int SCE_ADA_DEFAULT=0;
public const int SCE_ADA_WORD=1;
public const int SCE_ADA_IDENTIFIER=2;
public const int SCE_ADA_NUMBER=3;
public const int SCE_ADA_DELIMITER=4;
public const int SCE_ADA_CHARACTER=5;
public const int SCE_ADA_CHARACTEREOL=6;
public const int SCE_ADA_STRING=7;
public const int SCE_ADA_STRINGEOL=8;
public const int SCE_ADA_LABEL=9;
public const int SCE_ADA_COMMENTLINE=10;
public const int SCE_ADA_ILLEGAL=11;
public const int SCE_BAAN_DEFAULT=0;
public const int SCE_BAAN_COMMENT=1;
public const int SCE_BAAN_COMMENTDOC=2;
public const int SCE_BAAN_NUMBER=3;
public const int SCE_BAAN_WORD=4;
public const int SCE_BAAN_STRING=5;
public const int SCE_BAAN_PREPROCESSOR=6;
public const int SCE_BAAN_OPERATOR=7;
public const int SCE_BAAN_IDENTIFIER=8;
public const int SCE_BAAN_STRINGEOL=9;
public const int SCE_BAAN_WORD2=10;
public const int SCE_LISP_DEFAULT=0;
public const int SCE_LISP_COMMENT=1;
public const int SCE_LISP_NUMBER=2;
public const int SCE_LISP_KEYWORD=3;
public const int SCE_LISP_STRING=6;
public const int SCE_LISP_STRINGEOL=8;
public const int SCE_LISP_IDENTIFIER=9;
public const int SCE_LISP_OPERATOR=10;
public const int SCE_EIFFEL_DEFAULT=0;
public const int SCE_EIFFEL_COMMENTLINE=1;
public const int SCE_EIFFEL_NUMBER=2;
public const int SCE_EIFFEL_WORD=3;
public const int SCE_EIFFEL_STRING=4;
public const int SCE_EIFFEL_CHARACTER=5;
public const int SCE_EIFFEL_OPERATOR=6;
public const int SCE_EIFFEL_IDENTIFIER=7;
public const int SCE_EIFFEL_STRINGEOL=8;
public const int SCE_NNCRONTAB_DEFAULT=0;
public const int SCE_NNCRONTAB_COMMENT=1;
public const int SCE_NNCRONTAB_TASK=2;
public const int SCE_NNCRONTAB_SECTION=3;
public const int SCE_NNCRONTAB_KEYWORD=4;
public const int SCE_NNCRONTAB_MODIFIER=5;
public const int SCE_NNCRONTAB_ASTERISK=6;
public const int SCE_NNCRONTAB_NUMBER=7;
public const int SCE_NNCRONTAB_STRING=8;
public const int SCE_NNCRONTAB_ENVIRONMENT=9;
public const int SCE_NNCRONTAB_IDENTIFIER=10;
public const int SCE_MATLAB_DEFAULT=0;
public const int SCE_MATLAB_COMMENT=1;
public const int SCE_MATLAB_COMMAND=2;
public const int SCE_MATLAB_NUMBER=3;
public const int SCE_MATLAB_KEYWORD=4;
public const int SCE_MATLAB_STRING=5;
public const int SCE_MATLAB_OPERATOR=6;
public const int SCE_MATLAB_IDENTIFIER=7;
public const int SCE_SCRIPTOL_DEFAULT=0;
public const int SCE_SCRIPTOL_WHITE=1;
public const int SCE_SCRIPTOL_COMMENTLINE=2;
public const int SCE_SCRIPTOL_PERSISTENT=3;
public const int SCE_SCRIPTOL_CSTYLE=4;
public const int SCE_SCRIPTOL_COMMENTBLOCK=5;
public const int SCE_SCRIPTOL_NUMBER=6;
public const int SCE_SCRIPTOL_STRING=7;
public const int SCE_SCRIPTOL_CHARACTER=8;
public const int SCE_SCRIPTOL_STRINGEOL=9;
public const int SCE_SCRIPTOL_KEYWORD=10;
public const int SCE_SCRIPTOL_OPERATOR=11;
public const int SCE_SCRIPTOL_IDENTIFIER=12;
public const int SCE_SCRIPTOL_TRIPLE=13;
public const int SCE_SCRIPTOL_CLASSNAME=14;
public const int SCE_SCRIPTOL_PREPROCESSOR=15;
public const int SCE_ASM_DEFAULT=0;
public const int SCE_ASM_COMMENT=1;
public const int SCE_ASM_NUMBER=2;
public const int SCE_ASM_STRING=3;
public const int SCE_ASM_OPERATOR=4;
public const int SCE_ASM_IDENTIFIER=5;
public const int SCE_ASM_CPUINSTRUCTION=6;
public const int SCE_ASM_MATHINSTRUCTION=7;
public const int SCE_ASM_REGISTER=8;
public const int SCE_ASM_DIRECTIVE=9;
public const int SCE_ASM_DIRECTIVEOPERAND=10;
public const int SCE_F_DEFAULT=0;
public const int SCE_F_COMMENT=1;
public const int SCE_F_NUMBER=2;
public const int SCE_F_STRING1=3;
public const int SCE_F_STRING2=4;
public const int SCE_F_STRINGEOL=5;
public const int SCE_F_OPERATOR=6;
public const int SCE_F_IDENTIFIER=7;
public const int SCE_F_WORD=8;
public const int SCE_F_WORD2=9;
public const int SCE_F_WORD3=10;
public const int SCE_F_PREPROCESSOR=11;
public const int SCE_F_OPERATOR2=12;
public const int SCE_F_LABEL=13;
public const int SCE_F_CONTINUATION=14;
public const int SCE_CSS_DEFAULT=0;
public const int SCE_CSS_TAG=1;
public const int SCE_CSS_CLASS=2;
public const int SCE_CSS_PSEUDOCLASS=3;
public const int SCE_CSS_UNKNOWN_PSEUDOCLASS=4;
public const int SCE_CSS_OPERATOR=5;
public const int SCE_CSS_IDENTIFIER=6;
public const int SCE_CSS_UNKNOWN_IDENTIFIER=7;
public const int SCE_CSS_VALUE=8;
public const int SCE_CSS_COMMENT=9;
public const int SCE_CSS_ID=10;
public const int SCE_CSS_IMPORTANT=11;
public const int SCE_CSS_DIRECTIVE=12;
public const int SCE_CSS_DOUBLESTRING=13;
public const int SCE_CSS_SINGLESTRING=14;
public const int SCE_POV_DEFAULT=0;
public const int SCE_POV_COMMENT=1;
public const int SCE_POV_COMMENTLINE=2;
public const int SCE_POV_NUMBER=3;
public const int SCE_POV_OPERATOR=4;
public const int SCE_POV_IDENTIFIER=5;
public const int SCE_POV_STRING=6;
public const int SCE_POV_STRINGEOL=7;
public const int SCE_POV_DIRECTIVE=8;
public const int SCE_POV_BADDIRECTIVE=9;
public const int SCE_POV_WORD2=10;
public const int SCE_POV_WORD3=11;
public const int SCE_POV_WORD4=12;
public const int SCE_POV_WORD5=13;
public const int SCE_POV_WORD6=14;
public const int SCE_POV_WORD7=15;
public const int SCE_POV_WORD8=16;
public const int SCE_LOUT_DEFAULT=0;
public const int SCE_LOUT_COMMENT=1;
public const int SCE_LOUT_NUMBER=2;
public const int SCE_LOUT_WORD=3;
public const int SCE_LOUT_WORD2=4;
public const int SCE_LOUT_WORD3=5;
public const int SCE_LOUT_WORD4=6;
public const int SCE_LOUT_STRING=7;
public const int SCE_LOUT_OPERATOR=8;
public const int SCE_LOUT_IDENTIFIER=9;
public const int SCE_LOUT_STRINGEOL=10;
public const int SCE_ESCRIPT_DEFAULT=0;
public const int SCE_ESCRIPT_COMMENT=1;
public const int SCE_ESCRIPT_COMMENTLINE=2;
public const int SCE_ESCRIPT_COMMENTDOC=3;
public const int SCE_ESCRIPT_NUMBER=4;
public const int SCE_ESCRIPT_WORD=5;
public const int SCE_ESCRIPT_STRING=6;
public const int SCE_ESCRIPT_OPERATOR=7;
public const int SCE_ESCRIPT_IDENTIFIER=8;
public const int SCE_ESCRIPT_BRACE=9;
public const int SCE_ESCRIPT_WORD2=10;
public const int SCE_ESCRIPT_WORD3=11;
public const int SCE_PS_DEFAULT=0;
public const int SCE_PS_COMMENT=1;
public const int SCE_PS_DSC_COMMENT=2;
public const int SCE_PS_DSC_VALUE=3;
public const int SCE_PS_NUMBER=4;
public const int SCE_PS_NAME=5;
public const int SCE_PS_KEYWORD=6;
public const int SCE_PS_LITERAL=7;
public const int SCE_PS_IMMEVAL=8;
public const int SCE_PS_PAREN_ARRAY=9;
public const int SCE_PS_PAREN_DICT=10;
public const int SCE_PS_PAREN_PROC=11;
public const int SCE_PS_TEXT=12;
public const int SCE_PS_HEXSTRING=13;
public const int SCE_PS_BASE85STRING=14;
public const int SCE_PS_BADSTRINGCHAR=15;
public const int SCE_NSIS_DEFAULT=0;
public const int SCE_NSIS_COMMENT=1;
public const int SCE_NSIS_STRINGDQ=2;
public const int SCE_NSIS_STRINGLQ=3;
public const int SCE_NSIS_STRINGRQ=4;
public const int SCE_NSIS_FUNCTION=5;
public const int SCE_NSIS_VARIABLE=6;
public const int SCE_NSIS_LABEL=7;
public const int SCE_NSIS_USERDEFINED=8;
public const int SCE_NSIS_SECTIONDEF=9;
public const int SCE_NSIS_SUBSECTIONDEF=10;
public const int SCE_NSIS_IFDEFINEDEF=11;
public const int SCE_NSIS_MACRODEF=12;
public const int SCE_NSIS_STRINGVAR=13;
public const int SCE_MMIXAL_LEADWS=0;
public const int SCE_MMIXAL_COMMENT=1;
public const int SCE_MMIXAL_LABEL=2;
public const int SCE_MMIXAL_OPCODE=3;
public const int SCE_MMIXAL_OPCODE_PRE=4;
public const int SCE_MMIXAL_OPCODE_VALID=5;
public const int SCE_MMIXAL_OPCODE_UNKNOWN=6;
public const int SCE_MMIXAL_OPCODE_POST=7;
public const int SCE_MMIXAL_OPERANDS=8;
public const int SCE_MMIXAL_NUMBER=9;
public const int SCE_MMIXAL_REF=10;
public const int SCE_MMIXAL_CHAR=11;
public const int SCE_MMIXAL_STRING=12;
public const int SCE_MMIXAL_REGISTER=13;
public const int SCE_MMIXAL_HEX=14;
public const int SCE_MMIXAL_OPERATOR=15;
public const int SCE_MMIXAL_SYMBOL=16;
public const int SCE_MMIXAL_INCLUDE=17;
public const int SCE_CLW_DEFAULT=0;
public const int SCE_CLW_LABEL=1;
public const int SCE_CLW_COMMENT=2;
public const int SCE_CLW_STRING=3;
public const int SCE_CLW_USER_IDENTIFIER=4;
public const int SCE_CLW_INTEGER_CONSTANT=5;
public const int SCE_CLW_REAL_CONSTANT=6;
public const int SCE_CLW_PICTURE_STRING=7;
public const int SCE_CLW_KEYWORD=8;
public const int SCE_CLW_COMPILER_DIRECTIVE=9;
public const int SCE_CLW_BUILTIN_PROCEDURES_FUNCTION=10;
public const int SCE_CLW_STRUCTURE_DATA_TYPE=11;
public const int SCE_CLW_ATTRIBUTE=12;
public const int SCE_CLW_STANDARD_EQUATE=13;
public const int SCE_CLW_ERROR=14;
public const int SCE_LOT_DEFAULT=0;
public const int SCE_LOT_HEADER=1;
public const int SCE_LOT_BREAK=2;
public const int SCE_LOT_SET=3;
public const int SCE_LOT_PASS=4;
public const int SCE_LOT_FAIL=5;
public const int SCE_LOT_ABORT=6;
public const int SCE_YAML_DEFAULT=0;
public const int SCE_YAML_COMMENT=1;
public const int SCE_YAML_IDENTIFIER=2;
public const int SCE_YAML_KEYWORD=3;
public const int SCE_YAML_NUMBER=4;
public const int SCE_YAML_REFERENCE=5;
public const int SCE_YAML_DOCUMENT=6;
public const int CARET_CENTER=0x02;
public const int CARET_XEVEN=0x08;
public const int CARET_XJUMPS=0x10;
public const int SCN_CHECKBRACE=2007;

// end_new_const

extern(C)
{
/////////////////////////// Scintilla.h ///////////////////////////////
	// Scintilla source code edit control
	/** @file Scintilla.h
	 ** Interface to the edit control.
	 **/
	// Copyright 1998-2003 by Neil Hodgson <neilh@scintilla.org>
	// The License.txt file describes the conditions under which this software may be distributed.
	
	// Most of this file is automatically generated from the Scintilla.iface interface definition
	// file which contains any comments about the definitions. HFacer.py does the generation.
	
	//#ifndef SCINTILLA_H
	//#define SCINTILLA_H
	
	//vesion(windows)
	//{
	// Return false on failure:
	//bool Scintilla_RegisterClasses(void *hInstance);
	//bool Scintilla_ReleaseResources();
	//}
	int Scintilla_LinkLexers();
	
	// Here should be placed typedefs for uptr_t, an unsigned integer type large enough to
	// hold a pointer and sptr_t, a signed integer large enough to hold a pointer.
	// May need to be changed for 64 bit platforms.
	
	//#if _MSC_VER >= 1300
	//#include <BaseTsd.h>
	//#endif
	//#ifdef MAXULONG_PTR
//	alias ulong uptr_t;//typedef ULONG_PTR uptr_t;
//	alias ulong sptr_t;//typedef LONG_PTR sptr_t;
	//#else
	//alias ulong uptr_t;//typedef unsigned long uptr_t;
	//alias long sptr_t;//typedef long sptr_t;
	//#endif
	
	//typedef sptr_t (*SciFnDirect)(sptr_t ptr, unsigned int iMessage, uptr_t wParam, sptr_t lParam);
		
	// These structures are defined to be exactly the same shape as the Win32
	// CHARRANGE, TEXTRANGE, FINDTEXTEX, FORMATRANGE, and NMHDR structs.
	// So older code that treats Scintilla as a RichEdit will work.
	
	struct CharacterRange {
		long cpMin;
		long cpMax;
	};
	
	struct TextRange {
		CharacterRange chrg;
		char *lpstrText;
	};

	struct TextToFind {
    	CharacterRange chrg;     // range to search
    	char *lpstrText;                // the search pattern (zero terminated)
    	CharacterRange chrgText; // returned as position of matching text
	};
	
	
//	//#ifdef PLATFORM_H
//	
//	// This structure is used in printing and requires some of the graphics types
//	// from Platform.h.  Not needed by most client code.
//	
//	struct RangeToFormat {
//		SurfaceID hdc;
//		SurfaceID hdcTarget;
//		PRectangle rc;
//		PRectangle rcPage;
//		CharacterRange chrg;
//	};
//	
//	//#endif
//	
	struct NotifyHeader {
		// hwndFrom is really an environment specifc window handle or pointer
		// but most clients of Scintilla.h do not have this type visible.
		//WindowID hwndFrom;
		void *hwndFrom;
		uint idFrom;
		uint code;
	};

	struct SCNotification {
		NotifyHeader nmhdr;
		int position;	// SCN_STYLENEEDED, SCN_MODIFIED, SCN_DWELLSTART, SCN_DWELLEND
		int ch;		// SCN_CHARADDED, SCN_KEY
		int modifiers;	// SCN_KEY
		int modificationType;	// SCN_MODIFIED
		char *text;	// SCN_MODIFIED
		int length;		// SCN_MODIFIED
		int linesAdded;	// SCN_MODIFIED
		int message;	// SCN_MACRORECORD
		uptr_t wParam;	// SCN_MACRORECORD
		sptr_t lParam;	// SCN_MACRORECORD
		int line;		// SCN_MODIFIED
		int foldLevelNow;	// SCN_MODIFIED
		int foldLevelPrev;	// SCN_MODIFIED
		int margin;		// SCN_MARGINCLICK
		int listType;	// SCN_USERLISTSELECTION
		int x;			// SCN_DWELLSTART, SCN_DWELLEND
		int y;		// SCN_DWELLSTART, SCN_DWELLEND
 	};
	
	// Deprecation section listing all API features that are deprecated and will
	// will be removed completely in a future version.
	// To enable these features define INCLUDE_DEPRECATED_FEATURES
	
	//#ifdef INCLUDE_DEPRECATED_FEATURES
	
	//#define SCI_SETCARETPOLICY 2369
	//#define CARET_CENTER 0x02
	//#define CARET_XEVEN 0x08
	//#define CARET_XJUMPS 0x10
	
	//#define SCN_POSCHANGED 2012
	//#define SCN_CHECKBRACE 2007
	
	//#endif
	
	//#endif

	struct ScintillaObject {
        GtkContainer cont;
        void *pscin;
	};

alias uint sptr_t;
alias uint uptr_t;

	guint           scintilla_get_type      ();
	GtkWidget*      scintilla_new           ();
	void            scintilla_set_id        (ScintillaObject *sci,int id);
	sptr_t          scintilla_send_message  (ScintillaObject *sci,uint iMessage, uptr_t wParam, sptr_t lParam);
	void            scintilla_release_resources();

// need to receive signals

	gulong g_signal_connect_data(gpointer instnce, gchar * detailed_signal, GCallback c_handler, gpointer data, /*GClosureNotify*/void* destroy_data, GConnectFlags connect_flags);
	
};


public:
interface ScintillaListener
{
	void scintillaCallback(SCNotification* scNotification);
}

void dumpNotification(SCNotification* scn)
{
	
	printf("NotifyHeader nmhdr;\n");
	printf(" nmhdr void *hwndFrom %X\n",scn.nmhdr.hwndFrom);
	printf(" nmhdr uint idFrom;   %d\n",scn.nmhdr.idFrom);
	printf(" nmhdr uint code;     %d\n",scn.nmhdr.code);

	printf("position         %d\n",(int)scn.position);
	printf("ch               %c\n",(char)scn.ch);
	printf("modifiers        %X\n",scn.modifiers);
	printf("modificationType %X\n",scn.modificationType);
	//printf("*text            %s\n",scn.text);
	printf("length           %d\n",scn.length);
	printf("linesAdded       %d\n",scn.linesAdded);
	printf("message          %d\n",scn.message);
	printf("wParam           %X\n",scn.wParam);
	printf("lParam           %X\n",scn.lParam);
	printf("line             %X\n",scn.line/13);
	printf("foldLevelNow     %d\n",scn.foldLevelNow);
	printf("foldLevelPrev    %d\n",scn.foldLevelPrev);
	printf("margin           %d\n",scn.margin);
	printf("listType         %d\n",scn.listType);
	printf("x                %d\n",scn.x);
	printf("y                %d\n",scn.y);
}

/**
 * The code editor
 */
public:
class Scintilla : Container
{

	public:
	void addScintillaListener(ScintillaListener listener)
	{
		g_signal_connect_data(gtkW(), "sci-notify\0", &notifySignal, listener, null, 0);
	}
	
	extern(C)
	{
		static void notifySignal(GtkWidget *w, gint wParam, SCNotification* scNotification, ScintillaListener listener)
		{
			listener.scintillaCallback(scNotification);
		}
	};
	
	private static int S_ID = 0;
	public:
	int ID;
	
	guint getType()
	{
		return scintilla_get_type();
	}
	
	/**
	 * Creates a new Scintilla 
	 */
	this()
	{
		super(scintilla_new());
		ID = S_ID++;
		scintilla_set_id ((ScintillaObject*)gtkW(), ID);
		//send(SCI_SETMARGINTYPEN, 2, SC_MARGIN_SYMBOL);
		//send(SCI_SETMARGINMASKN, 2, SC_MASK_FOLDERS);
		//send(SCI_SETMARGINSENSITIVEN, 2, true);
		//send(SCI_SETMARGINWIDTHN, 2, 34);
		//send(SCI_SETFOLDMARGINCOLOUR, true, 0xFF0000);
	}
	
	/**
	 * Dtor - calls release()
	 * @see release()
	 */
	~this()
	{
		release();
	}
	private:
	void setID(ScintillaObject *sci, int id)
	{
		scintilla_set_id (sci, id);
	}
	
	public:
	
	/**
	 * Send a message
	 * @param iMessage
	 * @param wParam
	 * @param lParam
	 * @return 
	 */
	sptr_t send(uint iMessage, uptr_t wParam, sptr_t lParam)
	{
		return scintilla_send_message((ScintillaObject*)gtkW(), iMessage, wParam, lParam);
	}
	
	/**
	 *  release scintilla resources
	 */
	void release()
	{
		scintilla_release_resources();
	}

	// decorators

	int getCurrPosition()
	{
		return send(SCI_GETCURRENTPOS, 0, 0);
	}
	
	int getCurrLine()
	{
		return send(SCI_LINEFROMPOSITION, send(SCI_GETCURRENTPOS,0,0), 0);
	}
	
	/**
	 * finds text from the current position
	 */
	int find(char[] findStr, int flags)
	{
		send(SCI_SETTARGETSTART, send(SCI_GETCURRENTPOS, 0, 0), 0);
		send(SCI_SETTARGETEND, send(SCI_GETLENGTH,0,0), 0);
		int r = send(SCI_SEARCHINTARGET, findStr.length, (sptr_t)(char*)findStr);
		if ( r >= 0 )
		{
			send(SCI_SETSEL, r, r + findStr.length);
		}
		return r;
	}
	
	char[] getSelected()
	{
		int start = send(SCI_GETSELECTIONSTART,0,0);
		int end = send(SCI_GETSELECTIONEND,0,0);
		char[] text = new char[end-start+1];
		char* p = &text[0];
		send(SCI_GETSELTEXT, 0, (sptr_t)p);
		return text = string.toString(p);
	}
	
	// language bits
	
	void setMakefileLex()
	{
		printf("setMakefileLex\n");
		send(SCI_SETLEXER, SCLEX_MAKEFILE, 0);
	}
	
	enum DLexTypes
	{
		TYPES = 20, // pickup here SCE_C_ give up
		MODS,
		ERROR,
		HEADER,
		FLOW,
		INHER,
	}
	void setDLex()
	{
		printf("setDLex\n");
		send(SCI_SETLEXER, SCLEX_CPP, 0);
		send(SCI_SETKEYWORDS, DLexTypes.TYPES-DLexTypes.TYPES, (sptr_t)(char*)
			" int bit char byte cent ubyte ucent uint ulong union ushort wchar"
			" cfloat cdouble creal real void"
			" enum double dchar short int long ifloat idouble ireal float"
		//);
		//send(SCI_SETKEYWORDS, DLexTypes.MODS, (sptr_t)(char*)
			" typedef abstract auto deprecated final struct interface class synchronized"
			" cast in out inout static private protected public volatile invariant"
		//);
		//send(SCI_SETKEYWORDS, DLexTypes.ERROR, (sptr_t)(char*)
			" throw try assert catch finally true false null"
		//);
		//send(SCI_SETKEYWORDS, DLexTypes.HEADER, (sptr_t)(char*)
			" const alias export import extern debug align asm version"
		//);
		//send(SCI_SETKEYWORDS, DLexTypes.FLOW, (sptr_t)(char*)
			" body break continue case default do else if switch for return goto while with"
		//);
		//send(SCI_SETKEYWORDS, DLexTypes.INHER, (sptr_t)(char*)
			" delegate function  this super new delete override "
		);
		
		send(SCI_STYLESETFORE, SCE_C_COMMENT, 0x008000);
		send(SCI_STYLESETFORE, SCE_C_COMMENTLINE, 0x008000);
		send(SCI_STYLESETFORE, SCE_C_COMMENTDOC, 0x008000);
		send(SCI_STYLESETFORE, SCE_C_NUMBER, 0x0000C0);
		send(SCI_STYLESETFORE, SCE_C_WORD, 0x0000C0);
		send(SCI_STYLESETFORE, SCE_C_STRING, 0x0000C0);
		send(SCI_STYLESETBOLD, SCE_C_OPERATOR, 1);
		send(SCI_STYLESETBOLD, SCE_C_STRING, 1);
		send(SCI_STYLESETBOLD, SCE_C_NUMBER, 1);
		//SCE_C_DEFAULT=0;
		//SCE_C_COMMENT=1;
		//SCE_C_COMMENTLINE=2;
		//SCE_C_COMMENTDOC=3;
		//SCE_C_NUMBER=4;
		//SCE_C_WORD=5;
		//SCE_C_STRING=6;
		//SCE_C_CHARACTER=7;
		//SCE_C_UUID=8;
		//SCE_C_PREPROCESSOR=9;
		//SCE_C_OPERATOR=10;
		//SCE_C_IDENTIFIER=11;
		//SCE_C_STRINGEOL=12;
		//SCE_C_VERBATIM=13;
		//SCE_C_REGEX=14;
		//SCE_C_COMMENTLINEDOC=15;
		//SCE_C_WORD2=16;
		//SCE_C_COMMENTDOCKEYWORD=17;
		//SCE_C_COMMENTDOCKEYWORDERROR=18;
		//SCE_C_GLOBALCLASS=19; 

		send(SCI_STYLESETFORE, DLexTypes.TYPES , 0x800000);
		send(SCI_STYLESETFORE, DLexTypes.MODS  , 0x008000);
		send(SCI_STYLESETFORE, DLexTypes.ERROR , 0x000080);
		send(SCI_STYLESETFORE, DLexTypes.HEADER, 0x808000);
		send(SCI_STYLESETFORE, DLexTypes.FLOW  , 0x800080);
		send(SCI_STYLESETFORE, DLexTypes.INHER , 0x008080);


		
		
		send(SCI_SETTABWIDTH, 4, 0);

		//send(SCI_ZOOMIN,0,0);
				
	}
		
}
	