/*
 * leds
 * Linux Editor for D 
 * S as in simple(superfluous) or supperb
 * 
 * by Antonio Monteiro
 */

module leds.SystemConsole;

private import dui.All;

private import leds.Workspace;
private import leds.Docker;
private import leds.POpen;


/**
 * SystemConsole
 */
public:
class SystemConsole : ScrolledWindow , Dockable , POpenLineListener , MenuItemListener
{
	
	TextView textView;
	Workspace workspace;
	Menu tabMenu;
	Docker docker;
	/**
	 * Creates a new System console for a workspace
	 * @param workspace
	 */
	this(Workspace workspace)
	{
		this.workspace = workspace;
		setPolicy(PolicyType.AUTOMATIC, PolicyType.AUTOMATIC);
		textView = new TextView();
		add(textView);
	}

	Widget getWidget()
	{
		return this;
	}
	
	char[] getTabName()
	{
		return "system";
	}

	Menu getTabMenu()
	{
		if ( tabMenu === null )
		{
			tabMenu = new Menu();
			MenuItem item;
			
			tabMenu.append(new MenuItem(this,"_Float","tabMenu.float"));
		}
		return null;
	}

	void setDocker(Docker docker)
	{
		this.docker = docker;
	}

	/**
	 * clears all previews output
	 * \todo
	 */
	void clear()
	{
	}
	
	/**
	 * executes a system command
	 * @param command
	 */
	void exec(char[] command)
	{
		TextBuffer buf = textView.getBuffer();
		TextIter iter = new TextIter();
		buf.getEndIter(iter);
		buf.insert(iter, "\n*** Executing: "~command~"\n");
		
		POpen popen = new POpen(this, command ~ " 2>&1",POpenMode.READ, true);
	}

	//bit popenByteCallback(byte byteRead)
	//{
	//	printf("%c ",byteRead, byteRead);
	//	return false;
	//}
	
	bit popenLineCallback(char[] line)
	{
		TextBuffer buf = textView.getBuffer();
		TextIter iter = new TextIter();
		buf.getEndIter(iter);
		buf.insert(iter, line~"\n");
		gdouble within_margin = 0.0;
		bit use_align = false;
		gdouble xalign = 0.0;
		gdouble yalign = 0.0;
		textView.scrollToIter(iter, within_margin, use_align, xalign, yalign);
		//textView.draw();
		return false;
	}
	
	void popenClosed(char[] command)
	{
		TextBuffer buf = textView.getBuffer();
		TextIter iter = new TextIter();
		buf.getEndIter(iter);
		buf.insert(iter, "\n*** Finished: "~command~"\n");
		gdouble within_margin = 0.0;
		bit use_align = false;
		gdouble xalign = 0.0;
		gdouble yalign = 0.0;
		textView.scrollToIter(iter, within_margin, use_align, xalign, yalign);
	}
	
	void activateItemCallback(MenuItem menuItem, char [] action)
	{
		printf("Workspace.MenuListener.ctivateItemCallback %.*s\n",action);
	}

	/**
	 * Menu listener callback
	 */
	void activateCallback(MenuItem menuItem, char [] action)
	{
		switch(action)
		{
			case "tabMenu.float":
				break;

			default:
				break;
		}
	}

};